// Code generated by entc, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"

	"entgo.io/ent/dialect/sql"
	"github.com/valocode/bubbly/ent/license"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releasecomponent"
	"github.com/valocode/bubbly/ent/releaselicense"
)

// ReleaseLicense is the model entity for the ReleaseLicense schema.
type ReleaseLicense struct {
	config
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ReleaseLicenseQuery when eager-loading is set.
	Edges                     ReleaseLicenseEdges `json:"edges"`
	release_license_license   *int
	release_license_component *int
	release_license_release   *int
}

// ReleaseLicenseEdges holds the relations/edges for other nodes in the graph.
type ReleaseLicenseEdges struct {
	// License holds the value of the license edge.
	License *License `json:"license,omitempty"`
	// Component holds the value of the component edge.
	Component *ReleaseComponent `json:"component,omitempty"`
	// Release holds the value of the release edge.
	Release *Release `json:"release,omitempty"`
	// Scans holds the value of the scans edge.
	Scans []*CodeScan `json:"scans,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [4]bool
}

// LicenseOrErr returns the License value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ReleaseLicenseEdges) LicenseOrErr() (*License, error) {
	if e.loadedTypes[0] {
		if e.License == nil {
			// The edge license was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: license.Label}
		}
		return e.License, nil
	}
	return nil, &NotLoadedError{edge: "license"}
}

// ComponentOrErr returns the Component value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ReleaseLicenseEdges) ComponentOrErr() (*ReleaseComponent, error) {
	if e.loadedTypes[1] {
		if e.Component == nil {
			// The edge component was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: releasecomponent.Label}
		}
		return e.Component, nil
	}
	return nil, &NotLoadedError{edge: "component"}
}

// ReleaseOrErr returns the Release value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ReleaseLicenseEdges) ReleaseOrErr() (*Release, error) {
	if e.loadedTypes[2] {
		if e.Release == nil {
			// The edge release was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: release.Label}
		}
		return e.Release, nil
	}
	return nil, &NotLoadedError{edge: "release"}
}

// ScansOrErr returns the Scans value or an error if the edge
// was not loaded in eager-loading.
func (e ReleaseLicenseEdges) ScansOrErr() ([]*CodeScan, error) {
	if e.loadedTypes[3] {
		return e.Scans, nil
	}
	return nil, &NotLoadedError{edge: "scans"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*ReleaseLicense) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case releaselicense.FieldID:
			values[i] = new(sql.NullInt64)
		case releaselicense.ForeignKeys[0]: // release_license_license
			values[i] = new(sql.NullInt64)
		case releaselicense.ForeignKeys[1]: // release_license_component
			values[i] = new(sql.NullInt64)
		case releaselicense.ForeignKeys[2]: // release_license_release
			values[i] = new(sql.NullInt64)
		default:
			return nil, fmt.Errorf("unexpected column %q for type ReleaseLicense", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the ReleaseLicense fields.
func (rl *ReleaseLicense) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case releaselicense.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			rl.ID = int(value.Int64)
		case releaselicense.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field release_license_license", value)
			} else if value.Valid {
				rl.release_license_license = new(int)
				*rl.release_license_license = int(value.Int64)
			}
		case releaselicense.ForeignKeys[1]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field release_license_component", value)
			} else if value.Valid {
				rl.release_license_component = new(int)
				*rl.release_license_component = int(value.Int64)
			}
		case releaselicense.ForeignKeys[2]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field release_license_release", value)
			} else if value.Valid {
				rl.release_license_release = new(int)
				*rl.release_license_release = int(value.Int64)
			}
		}
	}
	return nil
}

// QueryLicense queries the "license" edge of the ReleaseLicense entity.
func (rl *ReleaseLicense) QueryLicense() *LicenseQuery {
	return (&ReleaseLicenseClient{config: rl.config}).QueryLicense(rl)
}

// QueryComponent queries the "component" edge of the ReleaseLicense entity.
func (rl *ReleaseLicense) QueryComponent() *ReleaseComponentQuery {
	return (&ReleaseLicenseClient{config: rl.config}).QueryComponent(rl)
}

// QueryRelease queries the "release" edge of the ReleaseLicense entity.
func (rl *ReleaseLicense) QueryRelease() *ReleaseQuery {
	return (&ReleaseLicenseClient{config: rl.config}).QueryRelease(rl)
}

// QueryScans queries the "scans" edge of the ReleaseLicense entity.
func (rl *ReleaseLicense) QueryScans() *CodeScanQuery {
	return (&ReleaseLicenseClient{config: rl.config}).QueryScans(rl)
}

// Update returns a builder for updating this ReleaseLicense.
// Note that you need to call ReleaseLicense.Unwrap() before calling this method if this ReleaseLicense
// was returned from a transaction, and the transaction was committed or rolled back.
func (rl *ReleaseLicense) Update() *ReleaseLicenseUpdateOne {
	return (&ReleaseLicenseClient{config: rl.config}).UpdateOne(rl)
}

// Unwrap unwraps the ReleaseLicense entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (rl *ReleaseLicense) Unwrap() *ReleaseLicense {
	tx, ok := rl.config.driver.(*txDriver)
	if !ok {
		panic("ent: ReleaseLicense is not a transactional entity")
	}
	rl.config.driver = tx.drv
	return rl
}

// String implements the fmt.Stringer.
func (rl *ReleaseLicense) String() string {
	var builder strings.Builder
	builder.WriteString("ReleaseLicense(")
	builder.WriteString(fmt.Sprintf("id=%v", rl.ID))
	builder.WriteByte(')')
	return builder.String()
}

// ReleaseLicenses is a parsable slice of ReleaseLicense.
type ReleaseLicenses []*ReleaseLicense

func (rl ReleaseLicenses) config(cfg config) {
	for _i := range rl {
		rl[_i].config = cfg
	}
}
